<?php

namespace Ups_transit\UPStransitStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClientInformationType UPStransitStruct
 * @package Ups_transit
 * @subpackage Structs
 */
class Ups_transitClientInformationType extends AbstractStructBase
{
    /**
     * The Property
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_transit\UPStransitStruct\Ups_transitProperty[]
     */
    public $Property;
    /**
     * Constructor method for ClientInformationType
     * @uses Ups_transitClientInformationType::setProperty()
     * @param \Ups_transit\UPStransitStruct\Ups_transitProperty[] $property
     */
    public function __construct(array $property = array())
    {
        $this
            ->setProperty($property);
    }
    /**
     * Get Property value
     * @return \Ups_transit\UPStransitStruct\Ups_transitProperty[]|null
     */
    public function getProperty()
    {
        return $this->Property;
    }
    /**
     * This method is responsible for validating the values passed to the setProperty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProperty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePropertyForArrayConstraintsFromSetProperty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $clientInformationTypePropertyItem) {
            // validation for constraint: itemType
            if (!$clientInformationTypePropertyItem instanceof \Ups_transit\UPStransitStruct\Ups_transitProperty) {
                $invalidValues[] = is_object($clientInformationTypePropertyItem) ? get_class($clientInformationTypePropertyItem) : sprintf('%s(%s)', gettype($clientInformationTypePropertyItem), var_export($clientInformationTypePropertyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Property property can only contain items of type \Ups_transit\UPStransitStruct\Ups_transitProperty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Property value
     * @throws \InvalidArgumentException
     * @param \Ups_transit\UPStransitStruct\Ups_transitProperty[] $property
     * @return \Ups_transit\UPStransitStruct\Ups_transitClientInformationType
     */
    public function setProperty(array $property = array())
    {
        // validation for constraint: array
        if ('' !== ($propertyArrayErrorMessage = self::validatePropertyForArrayConstraintsFromSetProperty($property))) {
            throw new \InvalidArgumentException($propertyArrayErrorMessage, __LINE__);
        }
        $this->Property = $property;
        return $this;
    }
    /**
     * Add item to Property value
     * @throws \InvalidArgumentException
     * @param \Ups_transit\UPStransitStruct\Ups_transitProperty $item
     * @return \Ups_transit\UPStransitStruct\Ups_transitClientInformationType
     */
    public function addToProperty(\Ups_transit\UPStransitStruct\Ups_transitProperty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_transit\UPStransitStruct\Ups_transitProperty) {
            throw new \InvalidArgumentException(sprintf('The Property property can only contain items of type \Ups_transit\UPStransitStruct\Ups_transitProperty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Property[] = $item;
        return $this;
    }
}
