<?php

namespace Ups_transit\UPStransitStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RequestShipFromAddressType UPStransitStruct
 * @package Ups_transit
 * @subpackage Structs
 */
class Ups_transitRequestShipFromAddressType extends AbstractStructBase
{
    /**
     * The Town
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Town;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $City;
    /**
     * The StateProvinceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $StateProvinceCode;
    /**
     * The CountryCode
     * @var string
     */
    public $CountryCode;
    /**
     * The PostalCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PostalCode;
    /**
     * Constructor method for RequestShipFromAddressType
     * @uses Ups_transitRequestShipFromAddressType::setTown()
     * @uses Ups_transitRequestShipFromAddressType::setCity()
     * @uses Ups_transitRequestShipFromAddressType::setStateProvinceCode()
     * @uses Ups_transitRequestShipFromAddressType::setCountryCode()
     * @uses Ups_transitRequestShipFromAddressType::setPostalCode()
     * @param string $town
     * @param string $city
     * @param string $stateProvinceCode
     * @param string $countryCode
     * @param string $postalCode
     */
    public function __construct($town = null, $city = null, $stateProvinceCode = null, $countryCode = null, $postalCode = null)
    {
        $this
            ->setTown($town)
            ->setCity($city)
            ->setStateProvinceCode($stateProvinceCode)
            ->setCountryCode($countryCode)
            ->setPostalCode($postalCode);
    }
    /**
     * Get Town value
     * @return string|null
     */
    public function getTown()
    {
        return $this->Town;
    }
    /**
     * Set Town value
     * @param string $town
     * @return \Ups_transit\UPStransitStruct\Ups_transitRequestShipFromAddressType
     */
    public function setTown($town = null)
    {
        // validation for constraint: string
        if (!is_null($town) && !is_string($town)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($town, true), gettype($town)), __LINE__);
        }
        $this->Town = $town;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \Ups_transit\UPStransitStruct\Ups_transitRequestShipFromAddressType
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get StateProvinceCode value
     * @return string|null
     */
    public function getStateProvinceCode()
    {
        return $this->StateProvinceCode;
    }
    /**
     * Set StateProvinceCode value
     * @param string $stateProvinceCode
     * @return \Ups_transit\UPStransitStruct\Ups_transitRequestShipFromAddressType
     */
    public function setStateProvinceCode($stateProvinceCode = null)
    {
        // validation for constraint: string
        if (!is_null($stateProvinceCode) && !is_string($stateProvinceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateProvinceCode, true), gettype($stateProvinceCode)), __LINE__);
        }
        $this->StateProvinceCode = $stateProvinceCode;
        return $this;
    }
    /**
     * Get CountryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->CountryCode;
    }
    /**
     * Set CountryCode value
     * @param string $countryCode
     * @return \Ups_transit\UPStransitStruct\Ups_transitRequestShipFromAddressType
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        $this->CountryCode = $countryCode;
        return $this;
    }
    /**
     * Get PostalCode value
     * @return string|null
     */
    public function getPostalCode()
    {
        return $this->PostalCode;
    }
    /**
     * Set PostalCode value
     * @param string $postalCode
     * @return \Ups_transit\UPStransitStruct\Ups_transitRequestShipFromAddressType
     */
    public function setPostalCode($postalCode = null)
    {
        // validation for constraint: string
        if (!is_null($postalCode) && !is_string($postalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postalCode, true), gettype($postalCode)), __LINE__);
        }
        $this->PostalCode = $postalCode;
        return $this;
    }
}
