<?php

namespace Ups_transit\UPStransitStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResponseShipListAddressType UPStransitStruct
 * @package Ups_transit
 * @subpackage Structs
 */
class Ups_transitResponseShipListAddressType extends AbstractStructBase
{
    /**
     * The Town
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Town;
    /**
     * The City
     * @var string
     */
    public $City;
    /**
     * The StateProvinceCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $StateProvinceCode;
    /**
     * The CountryCode
     * @var string
     */
    public $CountryCode;
    /**
     * The PostcodePrimaryLow
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PostcodePrimaryLow;
    /**
     * The PostcodePrimaryHigh
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PostcodePrimaryHigh;
    /**
     * Constructor method for ResponseShipListAddressType
     * @uses Ups_transitResponseShipListAddressType::setTown()
     * @uses Ups_transitResponseShipListAddressType::setCity()
     * @uses Ups_transitResponseShipListAddressType::setStateProvinceCode()
     * @uses Ups_transitResponseShipListAddressType::setCountryCode()
     * @uses Ups_transitResponseShipListAddressType::setPostcodePrimaryLow()
     * @uses Ups_transitResponseShipListAddressType::setPostcodePrimaryHigh()
     * @param string $town
     * @param string $city
     * @param string $stateProvinceCode
     * @param string $countryCode
     * @param string $postcodePrimaryLow
     * @param string $postcodePrimaryHigh
     */
    public function __construct($town = null, $city = null, $stateProvinceCode = null, $countryCode = null, $postcodePrimaryLow = null, $postcodePrimaryHigh = null)
    {
        $this
            ->setTown($town)
            ->setCity($city)
            ->setStateProvinceCode($stateProvinceCode)
            ->setCountryCode($countryCode)
            ->setPostcodePrimaryLow($postcodePrimaryLow)
            ->setPostcodePrimaryHigh($postcodePrimaryHigh);
    }
    /**
     * Get Town value
     * @return string|null
     */
    public function getTown()
    {
        return $this->Town;
    }
    /**
     * Set Town value
     * @param string $town
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setTown($town = null)
    {
        // validation for constraint: string
        if (!is_null($town) && !is_string($town)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($town, true), gettype($town)), __LINE__);
        }
        $this->Town = $town;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get StateProvinceCode value
     * @return string|null
     */
    public function getStateProvinceCode()
    {
        return $this->StateProvinceCode;
    }
    /**
     * Set StateProvinceCode value
     * @param string $stateProvinceCode
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setStateProvinceCode($stateProvinceCode = null)
    {
        // validation for constraint: string
        if (!is_null($stateProvinceCode) && !is_string($stateProvinceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateProvinceCode, true), gettype($stateProvinceCode)), __LINE__);
        }
        $this->StateProvinceCode = $stateProvinceCode;
        return $this;
    }
    /**
     * Get CountryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->CountryCode;
    }
    /**
     * Set CountryCode value
     * @param string $countryCode
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        $this->CountryCode = $countryCode;
        return $this;
    }
    /**
     * Get PostcodePrimaryLow value
     * @return string|null
     */
    public function getPostcodePrimaryLow()
    {
        return $this->PostcodePrimaryLow;
    }
    /**
     * Set PostcodePrimaryLow value
     * @param string $postcodePrimaryLow
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setPostcodePrimaryLow($postcodePrimaryLow = null)
    {
        // validation for constraint: string
        if (!is_null($postcodePrimaryLow) && !is_string($postcodePrimaryLow)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcodePrimaryLow, true), gettype($postcodePrimaryLow)), __LINE__);
        }
        $this->PostcodePrimaryLow = $postcodePrimaryLow;
        return $this;
    }
    /**
     * Get PostcodePrimaryHigh value
     * @return string|null
     */
    public function getPostcodePrimaryHigh()
    {
        return $this->PostcodePrimaryHigh;
    }
    /**
     * Set PostcodePrimaryHigh value
     * @param string $postcodePrimaryHigh
     * @return \Ups_transit\UPStransitStruct\Ups_transitResponseShipListAddressType
     */
    public function setPostcodePrimaryHigh($postcodePrimaryHigh = null)
    {
        // validation for constraint: string
        if (!is_null($postcodePrimaryHigh) && !is_string($postcodePrimaryHigh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcodePrimaryHigh, true), gettype($postcodePrimaryHigh)), __LINE__);
        }
        $this->PostcodePrimaryHigh = $postcodePrimaryHigh;
        return $this;
    }
}
