<?php

namespace Ups_transit\UPStransitStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipListType UPStransitStruct
 * @package Ups_transit
 * @subpackage Structs
 */
class Ups_transitShipListType extends AbstractStructBase
{
    /**
     * The Candidate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Ups_transit\UPStransitStruct\Ups_transitCandidateType[]
     */
    public $Candidate;
    /**
     * Constructor method for ShipListType
     * @uses Ups_transitShipListType::setCandidate()
     * @param \Ups_transit\UPStransitStruct\Ups_transitCandidateType[] $candidate
     */
    public function __construct(array $candidate = array())
    {
        $this
            ->setCandidate($candidate);
    }
    /**
     * Get Candidate value
     * @return \Ups_transit\UPStransitStruct\Ups_transitCandidateType[]|null
     */
    public function getCandidate()
    {
        return $this->Candidate;
    }
    /**
     * This method is responsible for validating the values passed to the setCandidate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCandidate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCandidateForArrayConstraintsFromSetCandidate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $shipListTypeCandidateItem) {
            // validation for constraint: itemType
            if (!$shipListTypeCandidateItem instanceof \Ups_transit\UPStransitStruct\Ups_transitCandidateType) {
                $invalidValues[] = is_object($shipListTypeCandidateItem) ? get_class($shipListTypeCandidateItem) : sprintf('%s(%s)', gettype($shipListTypeCandidateItem), var_export($shipListTypeCandidateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Candidate property can only contain items of type \Ups_transit\UPStransitStruct\Ups_transitCandidateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Candidate value
     * @throws \InvalidArgumentException
     * @param \Ups_transit\UPStransitStruct\Ups_transitCandidateType[] $candidate
     * @return \Ups_transit\UPStransitStruct\Ups_transitShipListType
     */
    public function setCandidate(array $candidate = array())
    {
        // validation for constraint: array
        if ('' !== ($candidateArrayErrorMessage = self::validateCandidateForArrayConstraintsFromSetCandidate($candidate))) {
            throw new \InvalidArgumentException($candidateArrayErrorMessage, __LINE__);
        }
        $this->Candidate = $candidate;
        return $this;
    }
    /**
     * Add item to Candidate value
     * @throws \InvalidArgumentException
     * @param \Ups_transit\UPStransitStruct\Ups_transitCandidateType $item
     * @return \Ups_transit\UPStransitStruct\Ups_transitShipListType
     */
    public function addToCandidate(\Ups_transit\UPStransitStruct\Ups_transitCandidateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_transit\UPStransitStruct\Ups_transitCandidateType) {
            throw new \InvalidArgumentException(sprintf('The Candidate property can only contain items of type \Ups_transit\UPStransitStruct\Ups_transitCandidateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Candidate[] = $item;
        return $this;
    }
}
