<?php

namespace Ups_transit;

/**
 * Class which returns the class map definition
 * @package Ups_transit
 */
class Ups_transitClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_transit\\UPStransitStruct\\Ups_transitUPSSecurity',
            'UsernameToken' => '\\Ups_transit\\UPStransitStruct\\Ups_transitUsernameToken',
            'ServiceAccessToken' => '\\Ups_transit\\UPStransitStruct\\Ups_transitServiceAccessToken',
            'Errors' => '\\Ups_transit\\UPStransitStruct\\Ups_transitErrors',
            'ErrorDetailType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitErrorDetailType',
            'ElementLevelInformationType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitElementLevelInformationType',
            'ElementIdentifierType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitElementIdentifierType',
            'CodeType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitCodeType',
            'AdditionalInfoType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitAdditionalInfoType',
            'AdditionalCodeDescType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitAdditionalCodeDescType',
            'LocationType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitLocationType',
            'ClientInformationType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitClientInformationType',
            'Property' => '\\Ups_transit\\UPStransitStruct\\Ups_transitProperty',
            'RequestType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitRequestType',
            'TransactionReferenceType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitTransactionReferenceType',
            'ResponseType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseType',
            'CodeDescriptionType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitCodeDescriptionType',
            'DetailType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitDetailType',
            'ResponseShipListAddressType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseShipListAddressType',
            'RequestShipFromAddressType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitRequestShipFromAddressType',
            'RequestShipToAddressType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitRequestShipToAddressType',
            'ResponseShipFromAddressType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseShipFromAddressType',
            'ResponseShipToAddressType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseShipToAddressType',
            'RequestShipFromType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitRequestShipFromType',
            'RequestShipToType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitRequestShipToType',
            'ResponseShipFromType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseShipFromType',
            'ResponseShipToType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitResponseShipToType',
            'ShipmentWeightType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitShipmentWeightType',
            'PickupType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitPickupType',
            'InvoiceLineTotalType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitInvoiceLineTotalType',
            'ReturnContractServicesType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitReturnContractServicesType',
            'TimeInTransitRequest' => '\\Ups_transit\\UPStransitStruct\\Ups_transitTimeInTransitRequest',
            'EstimatedArrivalType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitEstimatedArrivalType',
            'ServiceSummaryType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitServiceSummaryType',
            'TransitResponseType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitTransitResponseType',
            'CandidateType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitCandidateType',
            'ShipListType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitShipListType',
            'CandidateResponseType' => '\\Ups_transit\\UPStransitStruct\\Ups_transitCandidateResponseType',
            'TimeInTransitResponse' => '\\Ups_transit\\UPStransitStruct\\Ups_transitTimeInTransitResponse',
        );
    }
}
